<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'IdTagInfo' => '\\StructType\\IdTagInfo',
            'UnlockConnectorRequest' => '\\StructType\\UnlockConnectorRequest',
            'UnlockConnectorResponse' => '\\StructType\\UnlockConnectorResponse',
            'ResetRequest' => '\\StructType\\ResetRequest',
            'ResetResponse' => '\\StructType\\ResetResponse',
            'ChangeAvailabilityRequest' => '\\StructType\\ChangeAvailabilityRequest',
            'ChangeAvailabilityResponse' => '\\StructType\\ChangeAvailabilityResponse',
            'GetDiagnosticsRequest' => '\\StructType\\GetDiagnosticsRequest',
            'GetDiagnosticsResponse' => '\\StructType\\GetDiagnosticsResponse',
            'ClearCacheRequest' => '\\StructType\\ClearCacheRequest',
            'ClearCacheResponse' => '\\StructType\\ClearCacheResponse',
            'UpdateFirmwareRequest' => '\\StructType\\UpdateFirmwareRequest',
            'UpdateFirmwareResponse' => '\\StructType\\UpdateFirmwareResponse',
            'ChangeConfigurationRequest' => '\\StructType\\ChangeConfigurationRequest',
            'ChangeConfigurationResponse' => '\\StructType\\ChangeConfigurationResponse',
            'RemoteStartTransactionRequest' => '\\StructType\\RemoteStartTransactionRequest',
            'RemoteStartTransactionResponse' => '\\StructType\\RemoteStartTransactionResponse',
            'RemoteStopTransactionRequest' => '\\StructType\\RemoteStopTransactionRequest',
            'RemoteStopTransactionResponse' => '\\StructType\\RemoteStopTransactionResponse',
            'CancelReservationRequest' => '\\StructType\\CancelReservationRequest',
            'CancelReservationResponse' => '\\StructType\\CancelReservationResponse',
            'DataTransferRequest' => '\\StructType\\DataTransferRequest',
            'DataTransferResponse' => '\\StructType\\DataTransferResponse',
            'GetConfigurationRequest' => '\\StructType\\GetConfigurationRequest',
            'KeyValue' => '\\StructType\\KeyValue',
            'GetConfigurationResponse' => '\\StructType\\GetConfigurationResponse',
            'GetLocalListVersionRequest' => '\\StructType\\GetLocalListVersionRequest',
            'GetLocalListVersionResponse' => '\\StructType\\GetLocalListVersionResponse',
            'ReserveNowRequest' => '\\StructType\\ReserveNowRequest',
            'ReserveNowResponse' => '\\StructType\\ReserveNowResponse',
            'AuthorisationData' => '\\StructType\\AuthorisationData',
            'SendLocalListRequest' => '\\StructType\\SendLocalListRequest',
            'SendLocalListResponse' => '\\StructType\\SendLocalListResponse',
        );
    }
}
